package es.unican.docencia.y2011.eda.listaEnlazada.modular.noGenerica;

/**
 * Clase que sirve para lanzar el programa de prueba para el 
 * ejemplo de lista enlazada versin no orientada a objetos 
 * @author Pablo Sanchez (p.sanchez@unican.es)
 * 		   http://personales.unican.es/sanchezbp	
 */
public class Runner {

	/**
	 * Metodo de entrada a la aplicacion
	 * @param args Argumentos de la linea de comandos. Son simplemente ignorados
	 */
	public static void main(String[] args) {
		
		// Creamos algunos chinos mas o menos famosos
		Chino mao = new Chino();
		mao.setName("Mao Tse Tung");
		mao.setEdad(117);
		
		Chino zhang = new Chino();
		zhang.setName("Zhang Yimou");
		zhang.setEdad(59);
		
		Chino liu = new Chino();
		liu.setName("Liu Xiaobo");
		liu.setEdad(54);
 
		ListaEnlazadaChinos lista = ListaEnlazadaChinos.listaVacia();
		
		lista = ListaEnlazadaChinos.inserta(lista,mao);
		lista = ListaEnlazadaChinos.inserta(lista, zhang);
		lista = ListaEnlazadaChinos.inserta(lista,liu);
		
		System.out.println("Lista de chinos = " + ListaEnlazadaChinos.toString(lista));
		
		// Acabamos con la lista
		lista = ListaEnlazadaChinos.borra(lista,"Mao Tse Tung");
		System.out.println("Lista de chinos (1) = " + ListaEnlazadaChinos.toString(lista));
		lista = ListaEnlazadaChinos.borra(lista, "Zhang Yimou");
		System.out.println("Lista de chinos (2) = " + ListaEnlazadaChinos.toString(lista));
		lista = ListaEnlazadaChinos.borra(lista, "Liu Xiaobo");
		System.out.println("Lista de chinos (3) = " + ListaEnlazadaChinos.toString(lista));
		
		if (ListaEnlazadaChinos.esVacia(lista)) {
			System.out.println("La lista est vaca");
		} //if

		// Recreamos la lista
		lista = ListaEnlazadaChinos.inserta(lista,mao);
		lista = ListaEnlazadaChinos.inserta(lista, zhang);
		lista = ListaEnlazadaChinos.inserta(lista,liu);

		// Buscamos a Mao
		Chino mao2 = ListaEnlazadaChinos.busca(lista,"Mao Tse Tung");
		
		if (mao2 != null) {
			System.out.println("Chino encontrado con nombre " + mao2.getName() + " y edad " + mao2.getEdad());
		} // if
		
		// Este chino obviamente no existe 
		Chino noExiste = ListaEnlazadaChinos.busca(lista,"Alfredo Landa");
		if (noExiste == null) {
			System.out.println("No parece haber ningun chino llamado Alfredo Landa");
		} // if
		
		// Por problemas politicos, cambiamos a Liu por otro chino,
		Chino bruce = new Chino();
		bruce.setName("Bruce Lee");
		bruce.setEdad(70);
		
		lista = ListaEnlazadaChinos.actualiza(lista, "Liu Xiaobo", bruce);
		System.out.println("Lista de chinos (actualiza 1) = " + ListaEnlazadaChinos.toString(lista));
		
		// Vemos que pasa si queremos cambiar a Alfredo Landa (que no existe) por Mao
		lista = ListaEnlazadaChinos.actualiza(lista, "Alfredo Landa", mao);
		System.out.println("Lista de chinos (actualiza 2) = " + ListaEnlazadaChinos.toString(lista));
		
	} // main
	
} // Runner
